Home | History | Annotate | Download | only in buildit
      1 #!/bin/sh
      2 # LLVM LOCAL file B&I
      3 
      4 set -x
      5 
      6 # Build LLVM the "Apple way".
      7 # Parameters:
      8 
      9 # The first parameter is a space-separated list of the architectures the
     10 # compilers will run on. For instance, "ppc i386". If the current machine
     11 # isn't in the list, it will (effectively) be added.
     12 HOSTS="$1"
     13 
     14 # The second parameter is a space-separated list of the architectures the
     15 # compilers will generate code for. If the current machine isn't in the list, a
     16 # compiler for it will get built anyway, but won't be installed.
     17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
     18 TARGETS="$2"
     19 
     20 # The third parameter is the path to the compiler sources. There should be a
     21 # shell script named 'configure' in this directory. This script makes a copy...
     22 ORIG_SRC_DIR="$3"
     23 
     24 # The fourth parameter is the location where the LLVM will be installed. You can
     25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
     26 DEST_ROOT="$4"
     27 
     28 # The fifth parameter is the place where the compiler will be copied once it's
     29 # built.
     30 DEST_DIR="$5"
     31 
     32 # The sixth parameter is a directory in which to place information (like
     33 # unstripped executables and generated source files) helpful in debugging the
     34 # resulting compiler.
     35 SYM_DIR="$6"
     36 
     37 # The seventh parameter is a yes/no that indicates whether assertions should be
     38 # enabled in the LLVM libs/tools.
     39 LLVM_ASSERTIONS="$7"
     40 
     41 # The eighth parameter is a yes/no that indicates whether this is an optimized
     42 # build.
     43 LLVM_OPTIMIZED="$8"
     44 
     45 # A yes/no parameter that controls whether to cross-build for an ARM host.
     46 ARM_HOSTED_BUILD="$9"
     47 
     48 # A yes/no parameter that controls whether to cross-build for the iOS simulator
     49 IOS_SIM_BUILD="${10}"
     50 
     51 # The version number of the submission, e.g. 1007.
     52 LLVM_SUBMIT_VERSION="${11}"
     53 
     54 # The subversion number of the submission, e.g. 03.
     55 LLVM_SUBMIT_SUBVERSION="${12}"
     56 
     57 # The current working directory is where the build will happen. It may already
     58 # contain a partial result of an interrupted build, in which case this script
     59 # will continue where it left off.
     60 DIR=`pwd`
     61 
     62 DARWIN_VERS=`uname -r | sed 's/\..*//'`
     63 echo DARWIN_VERS = $DARWIN_VERS
     64 
     65 ################################################################################
     66 # Run the build.
     67 
     68 # Create the source tree we'll actually use to build, deleting
     69 # tcl since it doesn't actually build properly in a cross environment
     70 # and we don't really need it.
     71 SRC_DIR=$DIR/src
     72 rm -rf $SRC_DIR || exit 1
     73 mkdir $SRC_DIR || exit 1
     74 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
     75 # We can't use the top-level Makefile as-is.  Remove the soft link:
     76 rm $SRC_DIR/Makefile || exit 1
     77 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
     78 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
     79 
     80 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/.*\.\([0-9]*\).*/\1/'`
     81 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
     82     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
     83     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
     84     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
     85 fi
     86 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
     87     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
     88 else
     89     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
     90 fi
     91 
     92 # Figure out how many make processes to run.
     93 SYSCTL=`sysctl -n hw.activecpu`
     94 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
     95 # Builders can default to 2, since even if they are single processor,
     96 # nothing else is running on the machine.
     97 if [ -z "$SYSCTL" ]; then
     98     SYSCTL=2
     99 fi
    100 JOBS_FLAG="-j $SYSCTL"
    101 
    102 COMMON_CONFIGURE_OPTS="\
    103   --prefix=$DEST_DIR$DEST_ROOT \
    104   --enable-assertions=$LLVM_ASSERTIONS \
    105   --enable-optimized=$LLVM_OPTIMIZED \
    106   --disable-bindings"
    107 
    108 COMMON_MAKEFLAGS="\
    109   UNIVERSAL=1 \
    110   UNIVERSAL_SDK_PATH=$SDKROOT \
    111   NO_RUNTIME_LIBS=1 \
    112   DISABLE_EDIS=1 \
    113   REQUIRES_RTTI=1 \
    114   DEBUG_SYMBOLS=1 \
    115   LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
    116   LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
    117   VERBOSE=1"
    118 
    119 # Build the LLVM tree universal.
    120 mkdir -p $DIR/obj-llvm || exit 1
    121 cd $DIR/obj-llvm || exit 1
    122 
    123 if [ "$ARM_HOSTED_BUILD" = yes ]; then
    124   # The cross-tools' build process expects to find an existing cross toolchain
    125   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
    126   rm -rf $DIR/bin || exit 1
    127   mkdir $DIR/bin || exit 1
    128   for prog in ar nm ranlib strip lipo ld as ; do
    129     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
    130     T=`xcrun -sdk $SDKROOT -find ${prog}`
    131     ln -s $T $DIR/bin/$prog
    132     echo '#!/bin/sh' > $P || exit 1
    133     echo 'exec '$T' "$@"' >> $P || exit 1
    134     chmod a+x $P || exit 1
    135   done
    136   # Set up the links for clang.
    137   for prog in clang clang++ ; do
    138     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
    139     T=`xcrun -sdk $SDKROOT -find ${prog}`
    140     ln -s $T $DIR/bin/$prog
    141     echo '#!/bin/sh' > $P || exit 1
    142     echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
    143     chmod a+x $P || exit 1
    144   done
    145 
    146   PATH=$DIR/bin:$PATH
    147 
    148   unset SDKROOT && \
    149   $SRC_DIR/configure $COMMON_CONFIGURE_OPTS \
    150     --enable-targets=arm \
    151     --host=arm-apple-darwin10 \
    152     --target=arm-apple-darwin10 \
    153     --build=i686-apple-darwin10 \
    154     --program-prefix="" \
    155     || exit 1
    156 
    157   if [ -n "$IPHONEOS_DEPLOYMENT_TARGET" ]; then
    158     COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
    159       DEPLOYMENT_TARGET=-mios-version-min=$IPHONEOS_DEPLOYMENT_TARGET"
    160   fi
    161 
    162   make $JOBS_FLAG $COMMON_MAKEFLAGS SDKROOT= UNIVERSAL_ARCH="$HOSTS" \
    163     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
    164   if [ $? != 0 ] ; then
    165     echo "error: LLVM 'make' failed!"
    166     exit 1
    167   fi 
    168 
    169 else
    170 # not $ARM_HOSTED_BUILD
    171 
    172   export CC=`xcrun -find clang`
    173   export CXX=`xcrun -find clang++`
    174 
    175   if [ "$IOS_SIM_BUILD" = yes ]; then
    176     # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
    177     configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
    178                     --build=i686-apple-darwin10"
    179     if [ -n "$IPHONEOS_DEPLOYMENT_TARGET" ]; then
    180       COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
    181         DEPLOYMENT_TARGET=-mios-simulator-version-min=$IPHONEOS_DEPLOYMENT_TARGET"
    182     fi
    183   else
    184     configure_opts="--enable-targets=arm,x86"
    185     if [ -n "$MACOSX_DEPLOYMENT_TARGET" ]; then
    186       COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
    187         DEPLOYMENT_TARGET=-mmacosx-version-min=$MACOSX_DEPLOYMENT_TARGET"
    188     fi
    189   fi
    190 
    191   if [ $SDKROOT ]; then
    192     CPPFLAGS="$CPPFLAGS -isysroot $SDKROOT"
    193   fi
    194   for host in $HOSTS; do :; done
    195   CPPFLAGS="$CPPFLAGS -arch $host"
    196 
    197   $SRC_DIR/configure $COMMON_CONFIGURE_OPTS $configure_opts \
    198     --program-prefix="" \
    199     CPPFLAGS="$CPPFLAGS" \
    200     || exit 1
    201 
    202   make $JOBS_FLAG $COMMON_MAKEFLAGS UNIVERSAL_ARCH="$HOSTS" \
    203     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
    204   if [ $? != 0 ] ; then
    205     echo "error: LLVM 'make' failed!"
    206     exit 1
    207   fi 
    208 fi 
    209 
    210 ################################################################################
    211 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
    212 # $DEST_DIR, with occasional 'lipo' commands.
    213 
    214 cd $DEST_DIR || exit 1
    215 
    216 # Clean out DEST_DIR in case -noclean was passed to buildit.
    217 rm -rf * || exit 1
    218 
    219 cd $DIR/obj-llvm || exit 1
    220 
    221 # Install the tree into the destination directory.
    222 make $JOBS_FLAG $COMMON_MAKEFLAGS UNIVERSAL_ARCH="$HOSTS" install
    223 if ! test $? == 0 ; then
    224     echo "error: LLVM 'make install' failed!"
    225     exit 1
    226 fi 
    227 
    228 # Install Version.h
    229 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
    230 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
    231     LLVM_MINOR_VERSION=0
    232 fi
    233 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
    234 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
    235 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
    236 
    237 # Run unifdef to preprocess the installed headers to reflect whether this
    238 # was a debug or release build.
    239 for file in `find $DEST_DIR$DEST_ROOT/include -type f -print`; do
    240   if [ "$LLVM_ASSERTIONS" = yes ]; then
    241     unifdef -UNDEBUG -D_DEBUG -o $file $file
    242   else
    243     unifdef -DNDEBUG -U_DEBUG -ULLVM_ENABLE_DUMP -o $file $file
    244   fi
    245 done
    246 
    247 # Find the right version of strip to use.
    248 STRIP=strip
    249 if [ -n "$SDKROOT" ]; then
    250   STRIP=`xcrun -sdk $SDKROOT -find strip`
    251 fi
    252 
    253 if [ "x$LLVM_DEBUG" != "x1" ]; then
    254     # Strip local symbols from llvm libraries.
    255     #
    256     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
    257     # PPC objects!
    258     $STRIP -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
    259     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
    260         $STRIP -Sxl $f
    261     done
    262 fi
    263 
    264 # Remove .dir files 
    265 cd $DEST_DIR$DEST_ROOT
    266 rm -f bin/.dir etc/llvm/.dir lib/.dir
    267 
    268 # The Hello dylib is an example of how to build a pass.
    269 # The BugpointPasses module is only used to test bugpoint.
    270 # These unversioned dylibs cause verification failures, so do not install them.
    271 # (The wildcards are used to match a "lib" prefix if it is present.)
    272 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
    273 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
    274 
    275 # Compress manpages
    276 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
    277 gzip -f $MDIR/*
    278 
    279 ################################################################################
    280 # Create SYM_DIR with information required for debugging.
    281 
    282 # Figure out how many make processes to run.
    283 SYSCTL=`sysctl -n hw.activecpu`
    284 
    285 # hw.activecpu only available in 10.2.6 and later
    286 if [ -z "$SYSCTL" ]; then
    287   SYSCTL=`sysctl -n hw.ncpu`
    288 fi
    289 
    290 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
    291 # can default to 2, since even if they are single processor, nothing else is
    292 # running on the machine.
    293 if [ -z "$SYSCTL" ]; then
    294   SYSCTL=2
    295 fi
    296 
    297 cd $SYM_DIR || exit 1
    298 
    299 # Clean out SYM_DIR in case -noclean was passed to buildit.
    300 rm -rf * || exit 1
    301 
    302 # Generate .dSYM files
    303 DSYMUTIL=`xcrun -find dsymutil`
    304 find $DEST_DIR -perm -0111 -type f \
    305     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
    306     -print | xargs -n 1 -P ${SYSCTL} ${DSYMUTIL}
    307 
    308 # Save .dSYM files and .a archives
    309 cd $DEST_DIR || exit 1
    310 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
    311     | cpio -pdml $SYM_DIR || exit 1
    312 
    313 # Save source files.
    314 mkdir $SYM_DIR/src || exit 1
    315 cd $DIR || exit 1
    316 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
    317     | cpio -pdml $SYM_DIR/src || exit 1
    318 
    319 ################################################################################
    320 # Remove libLTO.dylib and lto.h.  Those are installed by clang.
    321 
    322 cd $DEST_DIR$DEST_ROOT
    323 rm -f lib/libLTO.dylib
    324 rm -f lib/libLTO.a lib/libLTO.la
    325 find $DEST_DIR$DEST_ROOT -name lto.h -delete
    326 
    327 ################################################################################
    328 # Remove debugging information from DEST_DIR.
    329 
    330 cd $DIR || exit 1
    331 
    332 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
    333 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
    334 
    335 # Strip debugging information from files
    336 #
    337 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
    338 # PPC objects!
    339 find $DEST_DIR -perm -0111 -type f \
    340     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
    341     -print | xargs -n 1 -P ${SYSCTL} $STRIP -arch all -Sl
    342 
    343 chgrp -h -R wheel $DEST_DIR
    344 chgrp -R wheel $DEST_DIR
    345 
    346 ################################################################################
    347 # Remove the docs directory
    348 
    349 rm -rf $DEST_DIR$DEST_ROOT/docs
    350 
    351 ################################################################################
    352 # w00t! Done!
    353 
    354 exit 0
    355